
import java.rmi.*;
import java.rmi.server.*;

public class BankAccountImpl
        extends UnicastRemoteObject
        implements BankAccount
{
  private float value;

  public BankAccountImpl() throws RemoteException {
    super();
    value = 0;
  }

  public void deposit (float amount) throws RemoteException {
    value += amount;
  }

  public void withdraw (float amount) 
    throws OverdrawnException, RemoteException {
    if (value < amount)
      throw new OverdrawnException();
    value -= amount;
  }

  public float balance() throws RemoteException {
    return value;
  }

  public static void main(String[] args){
    // Create and install a security manager
    // System.setSecurityManager(new RMISecurityManager());
    try {
      BankAccount acct = new BankAccountImpl();
      String url = "rmi://localhost:1972/account1";
      // bind url to remote object
      Naming.bind(url, acct);
    } catch (Exception e){
      System.out.println("Account creation/binding error: " + e);
    }
  }

}


